Subject: RFC 4866 issues

From: Alfred Hönes <[email-masked]>
Date: Mon, 14 May 2007 17:10:24 +0200 (MESZ)

Hello,
after studying the recently published RFC 4866 (IP6 Enhanced
Route Optimization) authored by you, I would like to point
out three issues I found with the RFC text.

(1)  Section 4.2 -- mis-specification ?

Within Section 3.2, in the first paragraph on page 21, RFC 4866
twice specifies:
                                                         vvvvvvv
   ... the lifetime for the binding SHOULD be set to the maximum
   of MAX_xx_BINDING_LIFETIME and the value specified in the
   Lifetime field of the Binding Update message.

where '_xx_' is '_CGA_' and '_RR_', respectively.
The text then continues:
                                                     vvvvvvvvvvvvvvv
   The correspondent node may in either case grant a further reduced
   lifetime, but it MUST NOT accept a higher lifetime.

Apparently the former specification does not make sense to me,
and it does not match the latter:
Taking the *maximum* of the Lifetime field of the message and
a constant might *increase* the value, thus subsequently talking
about *further reducing* it is weird.

I strongly suspect that the word "maximum" should have been "minimum"
in both instances in that paragraph.

(2)  Section 4.5 -- under-specification

Within Section 4.5, the third paragraph on page 26 points to the
algorithm defined in Section 6 of RFC 3972 [2], but it does not
specify all the arguments required as input to that algorithm;
it does not specify the CGA Message Type tag to be used in
calculating the CGA signature.

Later on in the RFC, Section 4.6 (on page 27), when describing
the CGA signature verification process, specifies the use of the
message tag given in Section 7 of RFC 4866.

For completeness and consistency, suitable text resembling the
last part of the last sentence of Section 4.6 should be added
to the third paragraph on page 26.

E.g., the sentence,

              [...].  The value is calculated with the mobile or
   correspondent node's private key over the following sequence of
   octets:

should better say:

              [...].  The value is calculated with the mobile or
|  correspondent node's private key and the CGA Message Type tag of
|  Enhanced Route Optimization as defined in Section 7, over the
   following sequence of octets:

(3)  CGA Specification -- missing Reference ?

The definition of the CGA parameter structure from RFC 3972
recently has been updated by RFC 4581.
Although RFC 4866 does not deal with the details of that structure,
for clarity, IMHO it should have specified whether this update
applies to the CGA parameters catrried in the CGA Parameters Option.
Otherwise, the sentence in Section 5.1, near the top of page 33,

   CGA Parameters

      This field contains up to 255 bytes of the CGA Parameters data
      structure defined in [2].  [...]

might be understood as excluding the update per RFC 4581, which most
probably was not intended.  To avoid this interpretation, the above
sentence should be corrected to say:

      This field contains up to 255 bytes of the CGA Parameters data
      structure as originally defined in [2] and recently updated in
      [2'].

and adding to Section 10.1 another Reference [2'] pointing to RFC 4581.

Please comment.

If you agree with the arguments presented, it might be worth to
address all these issues by an RFC Errata Note.

Preferrably, you should submit an Author's Errata Note to the
RFC Editor's RFC Errata web pages, making freely use of the
material supplied above.  But if you like, I can formally
submit an Errata Note on my own, with your consent.

Best regards,
  Alfred Hönes.

-- 

+------------------------+--------------------------------------------+
| TR-Sys Alfred Hoenes   |  Alfred Hoenes   Dipl.-Math., Dipl.-Phys.  |
| Gerlinger Strasse 12   |  Phone: (+49)7156/9635-0, Fax: -18         |
| D-71254  Ditzingen     |  E-Mail:  [email-masked]                     |
+------------------------+--------------------------------------------+

---

From: Alfred Hönes <[email-masked]>
Date: Mon, 14 May 2007 18:03:34 +0200 (MESZ)

Hello all,
in my recent note on RFC 4866, by accident I have omitted to mention
the last item on my list.
Here we go  ...

(4)

In Section 6.2, on top of page 43, RFC 4866 talks about

   "Enhanced Router Optimization"
                  ^
where it should talk about

   "Enhanced Route Optimization",

as usual.

  Alfred.